for i, effect in pairs(data.raw.technology["logistics"].effects ) do
	if effect.recipe == "fast-inserter" then table.remove(data.raw.technology["logistics"].effects, i) end
end
for i, effect in pairs(data.raw.technology["automation"].effects ) do
	if effect.recipe == "long-handed-inserter" then table.remove(data.raw.technology["automation"].effects, i) end
end
for i, effect in pairs(data.raw.technology["military-3"].effects ) do
	if effect.recipe == "slowdown-capsule" then table.remove(data.raw.technology["military-3"].effects, i) end
end
for i, effect in pairs(data.raw.technology["military-3"].effects ) do
	if effect.recipe == "poison-capsule" then table.remove(data.raw.technology["military-3"].effects, i) end
end

data.raw["recipe"]["basic-inserter"].enabled = false

data.raw["technology"]["logistics-2"].upgrade = true
data.raw["technology"]["logistics-3"].upgrade = true
data.raw["technology"]["logistics-3"].prerequisites = {"logistics-2"}
data.raw["technology"]["automation-2"].prerequisites = {"automation"}
data.raw["technology"]["automation-2"].upgrade = true
data.raw["technology"]["automation-3"].upgrade = true
data.raw["technology"]["automation-3"].prerequisites = {"automation-2"}
data.raw["technology"]["laser"].prerequisites = {"electronics"}
data.raw["technology"]["military-2"].upgrade = true
data.raw["technology"]["military-3"].upgrade = true
data.raw["technology"]["military-4"].upgrade = true
data.raw["technology"]["gates"].prerequisites = {"stone-walls", "steel-processing", "electronics"}
data.raw["technology"]["combat-robotics-2"].upgrade = true
data.raw["technology"]["combat-robotics-3"].upgrade = true
data.raw["technology"]["engine"].prerequisites = {"steel-processing"}
data.raw["technology"]["electric-energy-distribution-2"].upgrade = true
data.raw["technology"]["toolbelt"].prerequisites = {"advanced-electronics"}
data.raw["technology"]["electronics"].prerequisites = {}
data.raw["technology"]["electronics"].effects = {}
data.raw["technology"]["armor-making-2"].upgrade = true
data.raw["technology"]["armor-making-3"].upgrade = true
data.raw["technology"]["power-armor-2"].upgrade = true
data.raw["technology"]["armor-making-3"].prerequisites = {"armor-making-2", "advanced-electronics-2"}
data.raw["technology"]["power-armor-2"].prerequisites = {"power-armor", "alien-technology", "speed-module-3", "effectivity-module-3"}

data:extend
(
{
 {
  type = "technology", 
  name = "faster-crafting-1",
  icon = "__base__/graphics/icons/repair-pack.png",
  effects = {},
  prerequisites = {"toolbelt","research-effectivity-1"},
  unit =
  {
   count = 100,
   ingredients =
   {
    {"science-pack-1", 1},
    {"science-pack-2", 1}
   },
   time = 30
  }
 },
 {
  type = "technology",
  name = "faster-crafting-2",
  icon = "__base__/graphics/icons/repair-pack.png",
  effects = {},
  prerequisites = {"faster-crafting-1","toolbelt-2","research-effectivity-2"},
  unit =
  {
   count = 150,
   ingredients =
   {
    {"science-pack-1", 2},
    {"science-pack-2", 1}
   },
   time = 45
  },
  upgrade = true
 },
 {
  type = "technology",
  name = "faster-crafting-3",
  icon = "__base__/graphics/icons/repair-pack.png",
  effects = {},
  prerequisites = {"faster-crafting-2","research-effectivity-3", "power-armor"},
  unit =
  {
   count = 200,
   ingredients =
   {
    {"science-pack-1", 3},
    {"science-pack-2", 2},
    {"science-pack-3", 1}
   },
   time = 60
  },
  upgrade = true
 },
 {
  type = "technology",
  name = "faster-crafting-4",
  icon = "__base__/graphics/icons/repair-pack.png",
  effects = {},
  prerequisites = {"faster-crafting-3","research-effectivity-4","power-armor-2"},
  unit =
  {
   count = 250,
   ingredients =
   {
    {"science-pack-1", 4},
    {"science-pack-2", 3},
    {"science-pack-3", 2},
    {"alien-science-pack", 1}
   },
   time = 75
  },
  upgrade = true
 },
 {
  type = "technology",
  name = "faster-crafting-5",
  icon = "__base__/graphics/icons/repair-pack.png",
  effects = {},
  prerequisites = {"faster-crafting-4"},
  unit =
  {
   count = 300,
   ingredients =
   {
    {"science-pack-1", 5},
    {"science-pack-2", 3},
    {"science-pack-3", 2},
    {"alien-science-pack", 1}
   },
   time = 90
  },
  upgrade = true
 },
 {
  type = "technology",
  name = "faster-crafting-6",
  icon = "__base__/graphics/icons/repair-pack.png",
  effects = {},
  prerequisites = {"faster-crafting-5"},
  unit =
  {
   count = 350,
   ingredients =
   {
    {"science-pack-1", 5},
    {"science-pack-2", 4},
    {"science-pack-3", 3},
    {"alien-science-pack", 2},
   },
   time = 100
  },
  upgrade = true
 },
 {
  type = "technology",
  name = "faster-crafting-7",
  icon = "__base__/graphics/icons/repair-pack.png",
  effects = {},
  prerequisites = {"faster-crafting-6"},
  unit =
  {
   count = 400,
   ingredients =
   {
    {"science-pack-1", 6},
    {"science-pack-2", 5},
    {"science-pack-3", 4},
    {"alien-science-pack", 2},
   },
   time = 100
  },
  upgrade = true
 },
 {
  type = "technology",
  name = "faster-crafting-8",
  icon = "__base__/graphics/icons/repair-pack.png",
  effects = {},
  prerequisites = {"faster-crafting-7"},
  unit =
  {
   count = 450,
   ingredients =
   {
    {"science-pack-1", 7},
    {"science-pack-2", 6},
    {"science-pack-3", 5},
    {"alien-science-pack", 3},
   },
   time = 100
  },
  upgrade = true
 },
 {
  type = "technology",
  name = "faster-crafting-9",
  icon = "__base__/graphics/icons/repair-pack.png",
  effects = {},
  prerequisites = {"faster-crafting-8"},
  unit =
  {
   count = 500,
   ingredients =
   {
    {"science-pack-1", 8},
    {"science-pack-2", 7},
    {"science-pack-3", 6},
    {"alien-science-pack", 4},
   },
   time = 100
  },
  upgrade = true
 },
 {
  type = "technology",
  name = "faster-crafting-10",
  icon = "__base__/graphics/icons/repair-pack.png",
  effects = {},
  prerequisites = {"faster-crafting-9"},
  unit =
  {
   count = 600,
   ingredients =
   {
    {"science-pack-1", 10},
    {"science-pack-2", 10},
    {"science-pack-3", 10},
    {"alien-science-pack", 10},
   },
   time = 100
  },
  upgrade = true
 },
 {
  type = "technology",
  name = "inserter-1",
  icon = "__base__/graphics/icons/basic-inserter.png",
  effects =
  {
   {
    type = "unlock-recipe",
    recipe = "basic-inserter"
   },
   {
    type = "unlock-recipe",
	recipe = "long-handed-inserter"
   }
  },
  unit =
  {
   count = 20,
   ingredients =
   {
    {"science-pack-1", 1}
   },
   time = 15
  },
  upgrade = true
 },
 {
  type = "technology",
  name = "inserter-2",
  icon = "__base__/graphics/icons/fast-inserter.png",
  prerequisites = {"inserter-1"},
  effects =
  {
   {
    type = "unlock-recipe",
    recipe = "fast-inserter"
   },
   {
    type = "unlock-recipe",
	recipe = "smart-inserter"
   }
  },
  unit =
  {
   count = 40,
   ingredients =
   {
    {"science-pack-1", 1},
    {"science-pack-2", 1}
   },
   time = 30
  },
  upgrade = true
 },
 {
  type = "technology",
  name = "poison-capsule",
  prerequisites = {"military-3"},
  icon = "__base__/graphics/icons/poison-capsule.png",
  effects =
  {
   {
    type = "unlock-recipe",
    recipe = "poison-capsule"
   }
  },
  unit =
  {
   count = 20,
   ingredients =
   {
    {"science-pack-1", 1},
    {"science-pack-2", 1}
   },
   time = 20
  },
 },
 {
  type = "technology",
  name = "slowdown-capsule",
  prerequisites = {"poison-capsule"},
  icon = "__base__/graphics/icons/slowdown-capsule.png",
  effects =
  {
   {
	type = "unlock-recipe",
	recipe = "slowdown-capsule"
   }
  },
  unit =
  {
   count = 20,
   ingredients =
   {
	{"science-pack-1", 1},
    {"science-pack-2", 1}
   },
   time = 20
  },
 },
 {
  type = "technology",
  name = "toolbelt-2",
  prerequisites = {"advanced-electronics-2", "toolbelt"},
  icon = "__base__/graphics/technology/toolbelt.png",
  effects =
  {
   {
    type = "num-quick-bars",
    modifier = 1
   }
  },
  unit =
  {
   count = 100,
   ingredients =
   {
    {"science-pack-1", 3},
    {"science-pack-2", 3},
    {"science-pack-3", 3},
    {"alien-science-pack", 3}
   },
   time = 100
  },
  upgrade = true
 }
}
)

if data.raw.item["basic-inserter-left"] then
	table.insert(data.raw.technology["inserter-1"].effects,{type = "unlock-recipe", recipe = "basic-inserter-left"})
	table.insert(data.raw.technology["inserter-1"].effects,{type = "unlock-recipe", recipe = "basic-inserter-right"})
	table.insert(data.raw.technology["inserter-1"].effects,{type = "unlock-recipe", recipe = "long-handed-inserter-left"})
	table.insert(data.raw.technology["inserter-1"].effects,{type = "unlock-recipe", recipe = "long-handed-inserter-right"})
	table.insert(data.raw.technology["inserter-2"].effects,{type = "unlock-recipe", recipe = "fast-inserter-left"})
    table.insert(data.raw.technology["inserter-2"].effects,{type = "unlock-recipe", recipe = "fast-inserter-right"})
    table.insert(data.raw.technology["inserter-2"].effects,{type = "unlock-recipe", recipe = "smart-inserter-left"})
    table.insert(data.raw.technology["inserter-2"].effects,{type = "unlock-recipe", recipe = "smart-inserter-right"})
    for i, effect in pairs(data.raw.technology["logistics"].effects ) do
	if effect.recipe == "fast-inserter-left" then table.remove(data.raw.technology["logistics"].effects, i) end
    end
    for i, effect in pairs(data.raw.technology["logistics"].effects ) do
	if effect.recipe == "fast-inserter-right" then table.remove(data.raw.technology["logistics"].effects, i) end
    end
    for i, effect in pairs(data.raw.technology["automation"].effects ) do
	if effect.recipe == "long-handed-inserter-left" then table.remove(data.raw.technology["automation"].effects, i) end
    end
    for i, effect in pairs(data.raw.technology["automation"].effects ) do
	if effect.recipe == "long-handed-inserter-right" then table.remove(data.raw.technology["automation"].effects, i) end
    end
    data.raw["recipe"]["basic-inserter-left"].enabled = false
    data.raw["recipe"]["basic-inserter-right"].enabled = false
end